﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Threading;
using System.Threading;
using System.Windows.Media;

namespace Train
{
    /// <summary>
    /// Interaction logic for FormSignal.xaml
    /// </summary>
    public partial class FormSignal : Window
    {
        private int currentIndex = 1;
        private Data daten;
        private Button[] button = new Button[12];
        public FormSignal()
        {
            InitializeComponent();
        }
        public void ShowFormAndInput(Data Daten)
        {
            daten = Daten;
            ShowDialog();
        }
        private void ShowButton(int StartIndex, int EndIndex)
        {
            Wrap.Children.Clear();
            for (int i = 0; i < (EndIndex - StartIndex + 1); i++)
            {
                // Button
                button[i] = new Button();
                button[i].Width = 245;
                button[i].Height = 75;
                button[i].Margin = new Thickness(5);
                button[i].Tag = StartIndex + i - 1; // Index zuweisen

                // Grid
                Grid grid = new Grid();
                grid.Width = 245;
                grid.Height = 75;
                grid.ColumnDefinitions.Add(new ColumnDefinition());
                grid.ColumnDefinitions.Add(new ColumnDefinition());

                // Grid als Content des Button
                button[i].Content = grid;

                // Textblock
                TextBlock textBlock = new TextBlock();
                textBlock.FontSize = 16;
                textBlock.FontWeight = FontWeights.Bold;
                textBlock.Text = daten.SignalData[StartIndex + i - 1].Headline; ;

                // Textblock innerhalb des Grid Plazieren
                Grid.SetColumn(textBlock, 0);

                // Textblock zum Grid zuweisen
                grid.Children.Add(textBlock);

                // Button als Content zum WrapPanel
                Wrap.Children.Add(button[i]);

                // Ereignisse für den Button
                button[i].Click += new RoutedEventHandler(button_Click);

                switch (daten.SignalData[StartIndex + i - 1].Status)
                {
                    case DataItemSignal.SignalStatus.red:
                        button[i].Background = new SolidColorBrush(Colors.Red);
                        break;
                    case DataItemSignal.SignalStatus.green:
                        button[i].Background = new SolidColorBrush(Colors.Green);
                        break;
                    case DataItemSignal.SignalStatus.yellow:
                        button[i].Background = new SolidColorBrush(Colors.Yellow);
                        break;
                }
            
            }
            
            
        }
        void button_Click(object sender, RoutedEventArgs e)
        {

            Button button = (Button)sender;
            int index = (int)button.Tag;
            if (daten.SignalData[index].SignalTypThree == false)
            {
                // zweibegriffig
                if (daten.SignalData[index].Status == DataItemSignal.SignalStatus.red)
                {
                    daten.SignalData[index].Status = DataItemSignal.SignalStatus.green;
                    button.Background = new SolidColorBrush(Colors.Green);

                    int adress = daten.SignalData[index].AdressGreen;
                    CommunicationToInterface.Ligth(adress, daten.SignalData[index].ChanceGreen);
                }
                else
                {
                    daten.SignalData[index].Status = DataItemSignal.SignalStatus.red;
                    button.Background = new SolidColorBrush(Colors.Red);

                    int adress = daten.SignalData[index].AdressRed;
                    CommunicationToInterface.Ligth(adress, daten.SignalData[index].ChanceRed);
                }

            }
            else
            {
                // dreibegriffig
                if (daten.SignalData[index].Status == DataItemSignal.SignalStatus.red)
                {
                    daten.SignalData[index].Status = DataItemSignal.SignalStatus.green;
                    button.Background = new SolidColorBrush(Colors.Green);

                    int adress = daten.SignalData[index].AdressGreen;
                    CommunicationToInterface.Ligth(adress, daten.SignalData[index].ChanceGreen);
                }
                else if (daten.SignalData[index].Status == DataItemSignal.SignalStatus.green)
                {
                    daten.SignalData[index].Status = DataItemSignal.SignalStatus.yellow;
                    button.Background = new SolidColorBrush(Colors.Yellow);

                    int adress = daten.SignalData[index].AdressYellow;
                    CommunicationToInterface.Ligth(adress, daten.SignalData[index].ChanceYellow);
                }
                else
                {
                    daten.SignalData[index].Status = DataItemSignal.SignalStatus.red;
                    button.Background = new SolidColorBrush(Colors.Red);

                    int adress = daten.SignalData[index].AdressRed;
                    CommunicationToInterface.Ligth(adress, daten.SignalData[index].ChanceRed);
                }
            }
            buttonCancel.Focus();
        }


        private void buttonPre_Click(object sender, RoutedEventArgs e)
        {
            currentIndex = currentIndex + 12;
            int endIndex = currentIndex + 11;
            if (endIndex > daten.LigthData.Count) endIndex = daten.LigthData.Count;
            buttonBack.IsEnabled = true;
            if (endIndex <= daten.LigthData.Count)
            {
                buttonPre.IsEnabled = false;
            }
            ShowButton(currentIndex, endIndex);
        }

        private void buttonBack_Click(object sender, RoutedEventArgs e)
        {
            currentIndex = currentIndex - 12;
            int endIndex = currentIndex + 11;
            buttonPre.IsEnabled = true;
            if (currentIndex <= 1)
            {
                buttonBack.IsEnabled = false;
            }
            ShowButton(currentIndex, endIndex);
        }
        private static void DoEvents()
        {
            if (Application.Current != null)
                Application.Current.Dispatcher.Invoke(DispatcherPriority.Background, new ThreadStart(delegate { }));
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            int number;
            if (daten.SignalData.Count >= 12)
            {
                number = 12;
                if (daten.SignalData.Count > 12) buttonPre.IsEnabled = true;
            }
            else
            {
                number = daten.SignalData.Count;
                buttonPre.IsEnabled = false;
                buttonBack.IsEnabled = false;
            }
            ShowButton(1, number);
        }
    }
}
