﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Win32;
using System.IO;
using System.Reflection;

namespace Train
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private Data daten = new Data();
        public DataForGUI guiDate = new DataForGUI();
        public MainWindow()
        {  
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

        private void MenuItem_Click(object sender, RoutedEventArgs e)
        {
            AboutBox frmAboutBox = new AboutBox(this);
            frmAboutBox.ShowDialog();
        }

        private void MenuItem_Click_1(object sender, RoutedEventArgs e)
        {
            ConfigurationLight frmConfigurationLight = new ConfigurationLight();
            frmConfigurationLight.ShowFormAndInput(daten);
        }

        private void MenuItemImport_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = "Daten|*.xml";
            if (openFileDialog.ShowDialog() == true)
            {
                daten = Data.LoadFromXml(openFileDialog.FileName);
            }
        }

        private void MenuItem_Click_2(object sender, RoutedEventArgs e)
        {
            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.Filter = "Daten|*.xml";
            saveFileDialog.DefaultExt = "xml";
            if (saveFileDialog.ShowDialog() == true)
            {
                daten.SaveAsXml(saveFileDialog.FileName);
            }
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            string dir = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\daten.xml";
            if (File.Exists(dir))
            {
                daten = Data.LoadFromXml(dir);
            }
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            string dir = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\daten.xml";
            daten.SaveAsXml(dir);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            FormLight frmLight = new FormLight();
            frmLight.ShowFormAndInput(daten);
        }

        private void MenuItem_Click_3(object sender, RoutedEventArgs e)
        {
            Close();
        }

        private void MenuItem_Click_4(object sender, RoutedEventArgs e)
        {
            ConfigurationTrain frmConfigurationTrain = new ConfigurationTrain();
            frmConfigurationTrain.ShowFormAndInput(daten);
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            Drive();
        }

        private void Drive()
        {
            FormTrain formTrain = new FormTrain();
            guiDate.NumberOfWindows++;
            formTrain.ShowFormAndInput(daten, guiDate);
        }

        private void MenuItem_Click_5(object sender, RoutedEventArgs e)
        {
            ConfigurationSignal frmConfigurationSignal = new ConfigurationSignal();
            frmConfigurationSignal.ShowFormAndInput(daten);
        }

        private void MenuItem_Click_6(object sender, RoutedEventArgs e)
        {
            FormSignal frmSignal = new FormSignal();
            frmSignal.ShowFormAndInput(daten);
        }

        private void button2_Checked(object sender, RoutedEventArgs e)
        {
            CommunicationToInterface.AllOn();
        }

        private void toggleButtonOnOff_Unchecked(object sender, RoutedEventArgs e)
        {
            CommunicationToInterface.AllOff();
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            Plan();
        }

        private  void Plan()
        {
            FormPlan formPlan = new FormPlan();
            formPlan.ShowFormAndInput();
        }


        private void MenuItem_Click_8(object sender, RoutedEventArgs e)
        {
            Drive();
        }

        private void MenuItem_Click_7(object sender, RoutedEventArgs e)
        {
            Plan();
        }

        private void MenuItem_Click_9(object sender, RoutedEventArgs e)
        {
            ConfigurationPlan configurationPlan = new ConfigurationPlan();
            configurationPlan.ShowFormAndInput(daten);
        }
    }
}
